package AltiConsole;

import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.MissingResourceException;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.ImageIcon;

import config.UserPref;
import l10n.DebugTranslator;
import l10n.ResourceBundleTranslator;
import l10n.Translator;
import net.miginfocom.swing.MigLayout;
//import config.UserPref;
import config.Utils;
import config.URLLabel;
import config.StyledLabel;
import config.Chars;
import config.Icons;
import config.BuildProperties;
import config.StyledLabel.Style;
import config.DescriptionArea;
import javax.swing.ImageIcon;


public class AboutDialog extends JDialog{
	public static final String BEAR_ALTIMETER_URL = "http://rocket.payload.free.fr/";
	private static final Translator trans = Application.getTranslator();
	
	private static final String CREDITS = "<html><center>" +
			"<font size=\"+1\"><b>Altimeter Console has been developed by:</b></font><br><br>" +
			"Boris du Reau <br>" +
			"<b>Altimeter Console utilizes the following libraries:</b><br><br>" +
			"MiG Layout (http://www.miglayout.com/)<br>" +
			"JFreeChart (http://www.jfree.org/jfreechart/)<br>" +
			"RxtxSerial (http://www./)<br>";
	
	
	public AboutDialog(JFrame parent) {
		super(parent, true);
		
		final String version = BuildProperties.getVersion();
		//final String version ="0.6";
		
		JPanel panel = new JPanel(new MigLayout("fill"));
		JPanel sub;
		
		
		// Bear Altimeter logo
		
		ImageIcon mylogo = Icons.loadImageIcon("pix/bear_altimeters-small.png", "Bear Altimeter");
		
		if (mylogo == null)
			mylogo = Icons.loadImageIcon("bear_altimeters-small.png", "Bear Altimeter");
		
		panel.add(new JLabel(mylogo), "top");
		/*try{
		panel.add(new JLabel(Icons.loadImageIcon("pix/bear_altimeters-small.png", "Bear Altimeter")), "top");
		}
		catch (MissingResourceException e)
		{
			panel.add(new JLabel(Icons.loadImageIcon("bear_altimeters-small.png", "Bear Altimeter")), "top");

		}*/
		//panel.add(new JLabel("pix/icon/bear_altimeters-small.png"), "top");
		//panel.add(new JLabel(ImageIcon("pix/bear_altimeters-small.png", "Bear Altimeter")), "top");
		
		// OpenRocket version info + copyright
		sub = new JPanel(new MigLayout("fill"));
		
		sub.add(new StyledLabel("AltiConsole", 20), "ax 50%, growy, wrap para");
		sub.add(new StyledLabel(trans.get("lbl.version").trim() + " " + version, 3), "ax 50%, growy, wrap rel");
		sub.add(new StyledLabel("Copyright " + Chars.COPY + " 2012-2013 Boris du Reau"), "ax 50%, growy, wrap para");
		
		sub.add(new URLLabel(BEAR_ALTIMETER_URL), "ax 50%, growy, wrap para");
		panel.add(sub, "grow");
		
		
		// Translation information (if present)
		//String translation = trans.get("lbl.translation").trim();
		//String translator = trans.get("lbl.translator").trim();
		//String translatorWebsite = trans.get("lbl.translatorWebsite").trim();
		//String translatorIcon = trans.get("lbl.translatorIcon").trim();
		
		//if (translator.length() > 0 || translatorWebsite.length() > 0 || translatorIcon.length() > 0) {
			sub = new JPanel(new MigLayout("fill"));
			
			//sub.add(new StyledLabel(translation, Style.BOLD), "ax 50%, growy, wrap para");
			
			//if (translatorIcon.length() > 0) {
				//sub.add(new JLabel(Icons.loadImageIcon("pix/translators/" + translatorIcon, translator)),
					//	"ax 50%, growy, wrap para");
			//}
			//if (translator.length() > 0) {
				//sub.add(new JLabel(translator), "ax 50%, growy, wrap rel");
			//}
			//if (translatorWebsite.length() > 0) {
		//		sub.add(new URLLabel(translatorWebsite), "ax 50%, growy, wrap para");
			//}
			
			panel.add(sub);
		//}
		
		
		DescriptionArea info = new DescriptionArea(5);
		info.setText(CREDITS);
		panel.add(info, "newline, width 10px, height 150lp, grow, spanx, wrap para");
		
		//Close button
		JButton close = new JButton(trans.get("button.close"));
		close.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				AboutDialog.this.dispose();
			}
		});
		panel.add(close, "spanx, right");
		
		this.add(panel);
		this.setTitle("AltiConsole " + version);
		this.pack();
		this.setResizable(false);
		this.setLocationRelativeTo(parent);
		
		//GUIUtil.setDisposableDialogOptions(this, close);
	}
	private static AboutDialog dialog = null;
	public static void showPreferences(JFrame parent) {
		if (dialog != null) {
			dialog.dispose();
		}
		dialog = new AboutDialog(parent);
		dialog.setVisible(true);
	}
}
