package AltiConsole;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

import java.awt.Dialog;
//import java.awt.Frame;
import java.awt.BorderLayout;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Locale;

import javax.swing.JDialog;
import javax.swing.JComboBox;

import l10n.Translator;
//import java.util.Locale;


import net.miginfocom.swing.MigLayout;
import config.UserPref;
import config.Named;
import config.Utils;
//import net.sf.openrocket.util.Named;
//import net.sf.openrocket.util.Prefs;
//import net.sf.openrocket.util.Utils;
import java.awt.Dimension;

public class Preferences extends JDialog {

	private static final Translator trans = Application.getTranslator();

	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JButton close = null;
	private JComboBox jComboBoxLangage = null;
	private JComboBox jComboBoxUnit = null;
	private JComboBox jComboBoxComSpeed = null;
	private JPanel jPanelTop = null;



	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize(Window parent) {
		this.setSize(343, 200);
		this.setLocationRelativeTo(parent);
		this.setContentPane(getJContentPane());
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel(new MigLayout("fillx, ins 30lp n n n"));
			//		JPanel panel = new JPanel(new MigLayout("fillx, ins 30lp n n n"));

			//jContentPane.setLayout(new BorderLayout());
		}

		//Close
		close = new JButton(trans.get("dlg.but.close"));
		close.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				//this.setVisible(false);
				//jContentPane.close();//dispose();
				Preferences.this.dispose();
			}
		});
		//language
		jContentPane.add(new JLabel(trans.get("lbl.language")), "gapright para");
		jContentPane.add(getJComboBoxLangage(),"wrap rel, growx, sg combos");
		
		//Units
		jContentPane.add(new JLabel(trans.get("choose.lbl.unit")), "gapright para");	
		jContentPane.add(getJComboBoxUnits(),"wrap rel, growx, sg combos");

		//Default Com port speed
		jContentPane.add(new JLabel(trans.get("def.lbl.ComSpeed")), "gapright para");
		jContentPane.add(getJComboBoxComSpeed(),"wrap rel, growx, sg combos");
		
		jContentPane.add(close, "wrap");
		return jContentPane;
	}

	/**
	 * This method initializes jComboBoxLangage	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBoxLangage() {
		if (jComboBoxLangage == null) {
			//jComboBoxLangage = new JComboBox();
			//List<Locale> locales = new ArrayList<Locale>();

			////
			//// Language selector
			Locale userLocale = UserPref.getApplicationLocale();
			List<Named<Locale>> locales = new ArrayList<Named<Locale>>();
			for (Locale l : UserPref.getSupportedLocales()) {
				locales.add(new Named<Locale>(l, l.getDisplayLanguage()));
			}
			Collections.sort(locales);
			locales.add(0, new Named<Locale>(null, trans.get("languages.default")));
			
			//final JComboBox 
			jComboBoxLangage = new JComboBox(locales.toArray());
			for (int i = 0; i < locales.size(); i++) {
				if (Utils.equals(userLocale, locales.get(i).get())) {
					jComboBoxLangage.setSelectedIndex(i);
				}
			}
			jComboBoxLangage.addActionListener(new ActionListener() {
				@Override
				@SuppressWarnings("unchecked")
				public void actionPerformed(ActionEvent e) {
					Named<Locale> selection = (Named<Locale>) jComboBoxLangage.getSelectedItem();
					UserPref.setApplicationLocale(selection.get());
				}
			});
			
			///
		}
		return jComboBoxLangage;
	}

	private JComboBox getJComboBoxUnits() {
		if (jComboBoxUnit == null) {
			//jComboBoxLangage = new JComboBox();

			String userUnit = UserPref.getAppUnits();
			jComboBoxUnit = new JComboBox();
			
			jComboBoxUnit.insertItemAt(trans.get("Unit.Metrics"), 0);
			jComboBoxUnit.insertItemAt(trans.get("Unit.Imperial"), 1);
			//jComboBoxUnit.setSelectedIndex(0);
			if (Utils.equals(userUnit, "Unit.Metrics")) {
				jComboBoxUnit.setSelectedIndex(0);
			}
			else
				jComboBoxUnit.setSelectedIndex(1);
			
			
			jComboBoxUnit.addActionListener(new ActionListener() {
				@Override
				@SuppressWarnings("unchecked")
				public void actionPerformed(ActionEvent e) {
					String selection =  (String) jComboBoxUnit.getSelectedItem();
					if (Utils.equals(selection, trans.get("Unit.Metrics")))
						UserPref.setAppUnits("Unit.Metrics");
					else
						UserPref.setAppUnits("Unit.Imperial");
				}
			});

		}
		return jComboBoxUnit;
	}
	private JComboBox getJComboBoxComSpeed() {
		if (jComboBoxComSpeed == null) {

			//combo serial rate
			String[] serialRateStrings = {
				    	      "300","1200","2400","4800","9600","14400",
				    	      "19200","28800","38400","57600","115200"
				    	    };
			String ComSpeed = UserPref.getDefComSpeed();
			jComboBoxComSpeed = new JComboBox();
			for (int i = 0; i < serialRateStrings.length; i++)
			{
				jComboBoxComSpeed.addItem(serialRateStrings[i] ); 
				if (Utils.equals(ComSpeed, serialRateStrings[i])) {
					jComboBoxComSpeed.setSelectedIndex(i);
				}
			}
			
			jComboBoxComSpeed.addActionListener(new ActionListener() {
				@Override
				@SuppressWarnings("unchecked")
				public void actionPerformed(ActionEvent e) {
					String selection =  (String) jComboBoxComSpeed.getSelectedItem();
					UserPref.setDefComSpeed(selection);
				}
			});

		}
		return jComboBoxComSpeed;
	}

	/**
	 * This method initializes jPanelTop	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelTop() {
		if (jPanelTop == null) {
			/*GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints.gridy = 0;
			gridBagConstraints.weightx = 1.0;
			gridBagConstraints.gridx = 0;*/
			jPanelTop = new JPanel();
			jPanelTop.setLayout(new  BorderLayout());
			jPanelTop.add(getJComboBoxLangage(), BorderLayout.EAST);//, gridBagConstraints);
		}
		return jPanelTop;
	}
	private Preferences(Window parent) {
		//// Preferences
		super(parent, "Pref", Dialog.ModalityType.APPLICATION_MODAL);
		initialize(parent);
	}
	private static Preferences dialog = null;

	public static void showPreferences(Window parent) {
		if (dialog != null) {
			dialog.dispose();
		}
		dialog = new Preferences(parent);
		dialog.setVisible(true);
	}
	

}  //  @jve:decl-index=0:visual-constraint="10,10"
