package AltiConfig;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import net.miginfocom.swing.MigLayout;

import l10n.Translator;
//import AltiConsole.AboutDialog;
import AltiConsole.AltimeterSerial;
import AltiConsole.FlightData;
import AltiConfig.AltiConfigData;


import AltiConsole.Application;

public class AltiConfigDlg extends JDialog implements ActionListener{
	private static final Translator trans = Application.getTranslator();
	private JComboBox jComboBoxUnit = null;
	private JComboBox jComboBoxBeepingMode = null;
	private JComboBox jComboBoxOutputType = null;
	private JComboBox jComboBoxOutputType2 = null;
	private JComboBox jComboBoxOutputType3 = null;
	private JComboBox jComboBoxYesNo = null;
	private JSpinner spin = null;
	private static AltimeterSerial Serial;
	
	//Altimeter config variable
	/*private int units = 0;
	private int beepingMode = 0;
	private int output1 =0;
	private int output2 =1;
	private int output3 =2;
	private int supersonicYesNo =0;
	private int mainAltitude = 100;*/
	
	private static AltiConfigData Alticonfig=null;
	
	public AltiConfigDlg(JFrame parent) {
		super(parent, true);
		
		
		/*Alticonfig.setUnits(0);
		Alticonfig.setBeepingMode(0);
		Alticonfig.setOutput1(0);
		Alticonfig.setOutput2(1);
		Alticonfig.setOutput3(2);
		Alticonfig.setSupersonicYesNo(0);
		Alticonfig.setMainAltitude(100);*/
		
		JPanel panel = new JPanel(new MigLayout("fill"));
		//Altimeter name
		panel.add(new JLabel(trans.get("lbl.AltiName")), "gapright para");
		panel.add(new JLabel(Alticonfig.getAltimeterName()), "wrap rel, growx");
		//Altitude beeping mode
		panel.add(new JLabel(trans.get("lbl.AltBeepingMode")), "gapright para");
		panel.add(getJComboBoxBeepingMode(),"wrap rel, growx, sg combos");
		
		//Altitude Unit
		panel.add(new JLabel(trans.get("lbl.AltUnits")), "gapright para");
		panel.add(getJComboBoxUnits(),"wrap rel, growx, sg combos");
		
		//Altitude deployment for the main
		panel.add(new JLabel(trans.get("lbl.MainAlt")), "gapright para");
		
		SpinnerModel spinModel = new SpinnerNumberModel(0, //initial value
                0, //min
                200, //max
                1);  //step 
		spin = new JSpinner(spinModel);
		spin.setValue(Alticonfig.getMainAltitude());  
		spin.addChangeListener(new ChangeListener() {      
			  @Override
			  public void stateChanged(ChangeEvent e) {
			    // handle click
				  Alticonfig.setMainAltitude((Integer)spin.getValue());
			  }
			});

		panel.add(spin,"wrap rel, growx, sg combos");
		
		//Channel 1
		panel.add(new JLabel(trans.get("lbl.Channel1")), "gapright para");
		panel.add(getJComboBoxOutputType(),"wrap rel, growx, sg combos");
		
		//Channel 2
		panel.add(new JLabel(trans.get("lbl.Channel2")), "gapright para");
		panel.add(getJComboBoxOutputType2(),"wrap rel, growx, sg combos");
		
		//Channel 3
		panel.add(new JLabel(trans.get("lbl.Channel3")), "gapright para");
		panel.add(getJComboBoxOutputType3(),"wrap rel, growx, sg combos");
		
		//Supersonic mode
		panel.add(new JLabel(trans.get("lbl.SupersonicMode")), "gapright para");
		panel.add(getJComboHypersonicYesNo(),"wrap rel, growx, sg combos");
		
		//upload button
		JButton upload = new JButton(trans.get("button.uploadConfig"));
		upload.addActionListener(new ActionListener() {
		@Override
		public void actionPerformed(ActionEvent e) {
			uploadAltiConfig();
				AltiConfigDlg.this.dispose();
			}
		});
		
		//Close button
		JButton close = new JButton(trans.get("button.close"));
		close.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				AltiConfigDlg.this.dispose();
			}
		});
		panel.add(upload, "left");
		panel.add(close, "spanx, right");
		
		this.add(panel);
		this.setTitle(trans.get("title.AltimeterConfig"));
		this.pack();
		this.setResizable(false);
		this.setLocationRelativeTo(parent);
		//parent.
	}
	
	private JComboBox getJComboBoxBeepingMode() {
		if (jComboBoxBeepingMode == null) {
		
			jComboBoxBeepingMode = new JComboBox();
			jComboBoxBeepingMode.insertItemAt(trans.get("BeepMode.Mode1"), 0);
			jComboBoxBeepingMode.insertItemAt(trans.get("BeepMode.Mode2"), 1);
			jComboBoxBeepingMode.setSelectedIndex(Alticonfig.getBeepingMode());
			jComboBoxBeepingMode.setActionCommand("ComboBoxBeepingMode");
			jComboBoxBeepingMode.addActionListener(this);

		}
		return jComboBoxBeepingMode;
	}
	
	private JComboBox getJComboBoxUnits() {
		if (jComboBoxUnit == null) {
		
			jComboBoxUnit = new JComboBox();
			jComboBoxUnit.insertItemAt(trans.get("Unit.Meters"), 0);
			jComboBoxUnit.insertItemAt(trans.get("Unit.Feet"), 1);
			jComboBoxUnit.setSelectedIndex(Alticonfig.getUnits());
			jComboBoxUnit.setActionCommand("ComboBoxUnit");
			jComboBoxUnit.addActionListener(this);

		}
		return jComboBoxUnit;
	}
	
	private JComboBox getJComboHypersonicYesNo() {
		if (jComboBoxYesNo == null) {
			
			jComboBoxYesNo = new JComboBox();
			jComboBoxYesNo.insertItemAt(trans.get("supersonic.yes"), 0);
			jComboBoxYesNo.insertItemAt(trans.get("supersonic.no"), 1);
			jComboBoxYesNo.setSelectedIndex(Alticonfig.getSupersonicYesNo());
			jComboBoxYesNo.setActionCommand("ComboBoxYesNo");
			jComboBoxYesNo.addActionListener(this);

		}
		return jComboBoxYesNo;
	}
	
	private JComboBox getJComboBoxOutputType(){
		if (jComboBoxOutputType == null) {
			
			jComboBoxOutputType = new JComboBox();
			jComboBoxOutputType.insertItemAt(trans.get("OutputType.Main"), 0);
			jComboBoxOutputType.insertItemAt(trans.get("OutputType.Drogue"), 1);
			jComboBoxOutputType.insertItemAt(trans.get("OutputType.AirStart"), 2);
			jComboBoxOutputType.insertItemAt(trans.get("OutputType.Disabled"), 3);
			jComboBoxOutputType.setSelectedIndex(Alticonfig.getOutput1());
			jComboBoxOutputType.setActionCommand("ComboBoxOutputType");
			jComboBoxOutputType.addActionListener(this);

		}
		return jComboBoxOutputType;
	}
	
	private JComboBox getJComboBoxOutputType2(){
		if (jComboBoxOutputType2 == null) {
			
			jComboBoxOutputType2 = new JComboBox();
			jComboBoxOutputType2.insertItemAt(trans.get("OutputType.Main"), 0);
			jComboBoxOutputType2.insertItemAt(trans.get("OutputType.Drogue"), 1);
			jComboBoxOutputType2.insertItemAt(trans.get("OutputType.AirStart"), 2);
			jComboBoxOutputType2.insertItemAt(trans.get("OutputType.Disabled"), 3);
			jComboBoxOutputType2.setSelectedIndex(Alticonfig.getOutput2());
			jComboBoxOutputType2.setActionCommand("ComboBoxOutputType2");
			jComboBoxOutputType2.addActionListener(this);

		}
		return jComboBoxOutputType2;
	}
	
	private JComboBox getJComboBoxOutputType3(){
		if (jComboBoxOutputType3 == null) {
			
			jComboBoxOutputType3 = new JComboBox();
			jComboBoxOutputType3.insertItemAt(trans.get("OutputType.Main"), 0);
			jComboBoxOutputType3.insertItemAt(trans.get("OutputType.Drogue"), 1);
			jComboBoxOutputType3.insertItemAt(trans.get("OutputType.AirStart"), 2);
			jComboBoxOutputType3.insertItemAt(trans.get("OutputType.Disabled"), 3);
			jComboBoxOutputType3.setSelectedIndex(Alticonfig.getOutput3());
			jComboBoxOutputType3.setActionCommand("ComboBoxOutputType3");
			jComboBoxOutputType3.addActionListener(this);
		}
		return jComboBoxOutputType3;
	}
	
	private static AltiConfigDlg dialog = null;
	public static void showPreferences(JFrame parent, AltiConfigData pAlticonfig, AltimeterSerial pSerial) {
		Alticonfig =pAlticonfig;
		Serial = pSerial;
		
		if (dialog != null) {
			dialog.dispose();
		}
		dialog = new AltiConfigDlg(parent);
		
		dialog.setVisible(true);
	}
	
	public static  boolean retrieveAltiConfig(){
	
		return true;
	}
	
	public static boolean uploadAltiConfig(){
		
		System.out.println("Send back config\n");
		
		Serial.writeData("s," +
				Alticonfig.getUnits() +","+
		Alticonfig.getBeepingMode()+","+
		Alticonfig.getOutput1()+","+
		Alticonfig.getOutput2()+","+
		Alticonfig.getOutput3()+","+
		Alticonfig.getMainAltitude()+","+
		Alticonfig.getSupersonicYesNo() +
		";\n");
		return true;
	}
	
	  /**
     * Handles all the actions.
     *
     * @param e  the action event.
     */
    public void actionPerformed(final ActionEvent e) {
    	
    	
    	
    	if (e.getActionCommand().equals("ComboBoxBeepingMode"))
    	{
    		Alticonfig.setBeepingMode(jComboBoxBeepingMode.getSelectedIndex()) ;
    		System.out.println("We have a new selected value for beeping mode\n");
    	}
    	
    	if (e.getActionCommand().equals("ComboBoxUnit"))
    	{
    		Alticonfig.setUnits(jComboBoxUnit.getSelectedIndex()) ;
    		System.out.println("We have a new selected value for units\n");
    	}
    	
    	if (e.getActionCommand().equals("ComboBoxYesNo"))
    	{
    		Alticonfig.setSupersonicYesNo(jComboBoxYesNo.getSelectedIndex()) ;
    		System.out.println("We have a new selected value for supersonic mode\n");
    	}
    	
    	if (e.getActionCommand().equals("ComboBoxOutputType"))
    	{
    		Alticonfig.setOutput1(jComboBoxOutputType.getSelectedIndex()) ;
    		System.out.println("We have a new selected value for output type\n");
    	}
    	
    	if (e.getActionCommand().equals("ComboBoxOutputType2"))
    	{
    		Alticonfig.setOutput2(jComboBoxOutputType2.getSelectedIndex()) ;
    		System.out.println("We have a new selected value for output type\n");
    	}
    	
    	if (e.getActionCommand().equals("ComboBoxOutputType3"))
    	{
    		Alticonfig.setOutput3(jComboBoxOutputType2.getSelectedIndex()) ;
    		System.out.println("We have a new selected value for output type\n");
    	}
    	
    	/*if (e.getActionCommand().equals("ComboBoxBeepingMode"))
    	{
    		
    	}*/
    	
    }
	
}
